#!/usr/bin/perl

#
# (c) 2001 Jacek Konieczny <jajcus@pld.org.pl>
#
# This script translates .directory, *.applnk or *.desktop file
# from some locale-dependent encoding to utf8 
#
# file locale_short.charsets is used to get locale/charset pairs
#

my %charsets;

open CHARSETS,"<locale_short.charsets";
while(<CHARSETS>){
	chop;
	my ($locale,$charset)=split;
	$charsets{$locale}=$charset;
}
close CHARSETS;

while(<>){
	if (not /\[([^]]*)\]=/){
		print $_;
		next;
	}
	my ($locale,$charset)=($1,$charsets{$1});
	if (not defined($charset)){
		print STDERR "Unknown locale: $locale\n";
		print STDERR "Skipping: $_";
		next;
	}
	
	open PIPE,"|iconv -f $charset -t UTF-8";
	print PIPE $_;
	close PIPE;
}
